//#include <stdio.h>
//#include <stdarg.h>
#include <reg51.h>

#include "lcd_low_level_4bit.h"
#include "lcd_high_level.h"


/******************* internal Track XY cursor for NLs ***********************/
static signed char lcd_pos_x; lcd_pos_y;



/************************ lcd_setxy **************************/
static void lcd_setxy(void) reentrant {	// local function!
	unsigned char date;
	if(lcd_pos_x>19){	// Ensure that all is inside the visible rectangle
		lcd_pos_x=-1;
		lcd_pos_y++;
	}
	if(lcd_pos_y>1){
		lcd_pos_y=0;
		lcd_pos_x=-1;
	}else if(lcd_pos_y<0){
		lcd_pos_y=1;
		lcd_pos_x=-1;
	}

	switch(lcd_pos_y){	// Here for a 2x16 Display
		case 1: date=64; break;
		default: date=0;
	}
	date|=128;
	if(lcd_pos_x>0) date+=lcd_pos_x;
	lcd_combyte(date);
}

/*********************** lcd_gotoxy() *************************/
void lcd_gotoxy(char nx,char ny) reentrant{
	lcd_pos_x=nx;
	lcd_pos_y=ny;
	lcd_setxy();
}


/***************************************************** 
* lcd_putc(): send datebyte
*****************************************************/

void lcd_putc(unsigned char date) reentrant{
	unsigned char i;
	if(date==8){			/* Backspace */
		if(lcd_pos_x>0) lcd_pos_x--;
		lcd_setxy();
	}else if(date!='\n'){			/* ASCII char */
		if(lcd_pos_x<0){
			for(i=0;i<20;i++){	/* Clear line */
				lcd_databyte(' ');
			}
			lcd_pos_x=0;
			lcd_setxy();
		}
		lcd_databyte(date);	/* Highbyte */
		lcd_pos_x++;
	}
	if(lcd_pos_x>19 || date=='\n'){ /* Newline */
		lcd_pos_x=-1;
		lcd_pos_y++;
		lcd_setxy();
	}
} 

/******************** lcd_cgchars() ******************/
void lcd_cgchars(unsigned char *cdat){
	unsigned char i,c;
	lcd_combyte(64);		/* Set CG RAM addr. 0 */
	for(i=0;i<64;i++){
		c=*cdat++;
		lcd_databyte(c);	/* Write Bytes */
	}	
	lcd_setxy();	/* Restore old cursor position */
}

/******************** lcd_clear() ****************/
void lcd_clear(void){
	lcd_combyte(1);
	lcd_pos_x=0;
	lcd_pos_y=0;
}

/******************** lcd_cursor() ****************/
void lcd_cursor(unsigned char cur){
	lcd_combyte(cur+8);
}

/******************** lcd_init() *****************/
unsigned char lcd_init(void){		/* Return 1: ERROR, 0: OK */

	if(lcd_initport()) return 1; // Failed: NO DISPLAY?

	/* Now visible initialisation */
	lcd_combyte(15);	/* Display ON, Cursor on & blink */
	lcd_clear();
	lcd_cursor(LCD_CURSOR_BLINK);
	lcd_combyte(6);		/* Entry-Mode: Cursor Shift Right */
	return 0;		/* OK */
}

/************** lcd_printf() ********************/
/*int lcd_printf(far char* pfmt, ...){
        va_list(ap);
        va_start(ap,pfmt);
        return _doprnt(lcd_putc, pfmt, ap);
} */